<template>
    <v-container>
        <form>
            <v-text-field
            v-model="name"
            :error-messages="nameErrors"
            :counter="30"
            label="Отзыв"
            required
            @input="$v.name.$touch()"
            @blur="$v.name.$touch()"
            ></v-text-field>
            <v-select
            v-model="grade"
            :items="items"
            :error-messages="selectErrors"
            label="Оценка"
            required
            @change="$v.grade.$touch()"
            @blur="$v.grade.$touch()"
            ></v-select>
            <v-text-field
            v-model="description"
            :error-messages="descriptionErrors"
            :counter="200"
            label="Рецензия"
            required
            @input="$v.description.$touch()"
            @blur="$v.description.$touch()"
            ></v-text-field>
            <v-checkbox
            v-model="checkbox"
            :error-messages="checkboxErrors"
            label="Согласен с правилами сайта"
            required
            @change="$v.checkbox.$touch()"
            @blur="$v.checkbox.$touch()"
            ></v-checkbox>

            <v-btn x-large depressed
            class="mr-4 film__button"
            @click="addGrade()"
            >
            Отправить
            </v-btn>
            <v-btn x-large depressed
            class="film__button" @click="clear">
            Очистить
            </v-btn>
        </form>
    </v-container>
</template>
  
<script>
import { validationMixin } from 'vuelidate'
import { required, maxLength} from 'vuelidate/lib/validators'

export default {
    mixins: [validationMixin],

    validations: {
      name: { required, maxLength: maxLength(30) },
      grade: { required },
      description: { required },
      checkbox: {
        checked (val) {
          return val
        },
      },
    },

    data: () => ({
        name: '',
        description: '',
        grade: null,
        items: [
            '1',
            '2',
            '3',
            '4',
            '5',
        ],
        checkbox: false,
    }),

    computed: {
      checkboxErrors () {
        const errors = []
        if (!this.$v.checkbox.$dirty) return errors
        !this.$v.checkbox.checked && errors.push('You must agree to continue!')
        return errors
      },
      selectErrors () {
        const errors = []
        if (!this.$v.grade.$dirty) return errors
        !this.$v.grade.required && errors.push('Item is required')
        return errors
      },
      nameErrors () {
        const errors = []
        if (!this.$v.name.$dirty) return errors
        !this.$v.name.required && errors.push('Item is required.')  
        return errors
      },
      descriptionErrors () {
        const errors = []
        if (!this.$v.description.$dirty) return errors
        !this.$v.description.required && errors.push('Item is required.')  
        return errors
      },
    },

    methods: {
        addGrade() {
            this.$v.$touch()
            if (this.name != '' && this.description != '' && this.grade != null && this.checkbox != false) {
                let otsyv = {
                    id: Date.now(),
                    name: this.name,
                    grade: this.grade,
                    description: this.description,
                }   
                this.$emit('addGrade', otsyv)
                this.clear()
            }
        },
        clear () {
        this.$v.$reset()
        this.name = ''
        this.description = ''
        this.grade = null
        this.checkbox = false
        },
    },
};
</script>